#import <Cocoa/Cocoa.h>

/*
 * CMMethodProxy is a class for new classes defined in scripts.
 * Methods of CMMethodProxy are used by instances of the classes.
 *
 */
@interface CMMethodProxy : NSObject {

}

+ (id)defaultMethodProxy;

//
// accessing class/instance variables
//
+ (id)_objectOfVariable;
+ (id)_setVariableToObject:(id)anObject;
- (id)_objectOfVariable;
- (id)_setVariableToObject:(id)anObject;


//
// invoking methods
//
+ (id)_invoke;
+ (id)_invokeWithObject:(id)anObject;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7 :(id)anObject8;
+ (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7 :(id)anObject8 :(id)anObject9;
- (id)_invoke;
- (id)_invokeWithObject:(id)anObject;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7 :(id)anObject8;
- (id)_invokeWithObject:(id)anObject1 :(id)anObject2 :(id)anObject3
                       :(id)anObject4 :(id)anObject5 :(id)anObject6
                       :(id)anObject7 :(id)anObject8 :(id)anObject9;

//
// dealloc object
//
- (void)_dealloc;


//
// Key-Value Coding
//
- (id)_valueForKey:(NSString *)key;
- (void)_setValue:(id)value forKey:(NSString *)key;


//
// for overriding methods
//
+ (IMP)methodForEncodeType:(const char *)type;
id                 _forwardMessage(id self, SEL _cmd, ...);
int                _intForwardMessage(id self, SEL _cmd, ...);
unsigned int       _unsignedIntForwardMessage(id self, SEL _cmd, ...);
long               _longForwardMessage(id self, SEL _cmd, ...);
unsigned long      _unsignedLongForwardMessage(id self, SEL _cmd, ...);
long long          _longLongForwardMessage(id self, SEL _cmd, ...);
unsigned long long _unsignedLongLongForwardMessage(id self, SEL _cmd, ...);
double             _doubleForwardMessage(id self, SEL _cmd, ...);
char *             _charPointerforwardMessage(id self, SEL _cmd, ...);
SEL                _selForwardMessage(id self, SEL _cmd, ...);
NSRange            _rangeForwardMessage(id self, SEL _cmd, ...);
NSRect             _rectForwardMessage(id self, SEL _cmd, ...);
NSSize             _sizeForwardMessage(id self, SEL _cmd, ...);
NSPoint             _pointForwardMessage(id self, SEL _cmd, ...);
id                 _forwardMessageWithArguments(id self, SEL _cmd, va_list ap);

@end


